searchNodes=[{"doc":"A package containing generators to generate an admin backend for your Phoenix app. The package relies a lot on generators, and Mandarin itself provides a minimal API at runtime. This is be design, as the code produced with generators is easier to customize than overridable API calls, or other alternatives that depend a lot on macros. The basic idea is tha Mandarin generates normal Phoenix contexts, views, templates and controllers, much like the ones you'd write yourself. The generated files follow roughly the same conventinos as the ones you'd write yourself. Mandarin relies heavily on the forage package for filtering, sorting and paginating the results in the CRUD views.","ref":"Mandarin.html","title":"Mandarin","type":"module"},{"doc":"Convenience functions to design an application (paramsbase, schemas, contexts and HTML) in a programmatic way. This is equivalent to using the Phoenix and Mandarin generators, but with a nicer API which allows you to use the full power of the Elixir language to run the generators instead of relying on custom bash scripts or manually running the generators.","ref":"Mandarin.Designer.html","title":"Mandarin.Designer","type":"module"},{"doc":"","ref":"Mandarin.Designer.html#drop_migrations_if_already_exist/2","title":"Mandarin.Designer.drop_migrations_if_already_exist/2","type":"function"},{"doc":"Generate a mandarin context (without generating a web interface)","ref":"Mandarin.Designer.html#generate_mandarin_context/2","title":"Mandarin.Designer.generate_mandarin_context/2","type":"function"},{"doc":"Generate a mandarin context (without generating a web interface). If the params belong to a join_through table, this is the same as running generate_mandarin_schema(params) .","ref":"Mandarin.Designer.html#generate_mandarin_html/2","title":"Mandarin.Designer.generate_mandarin_html/2","type":"function"},{"doc":"Generate mandarin web interfaces (schemas, context and the web part) for a list of params. If the any params belong to a join_through table, this will run generate_mandarin_schema(params) for those params.","ref":"Mandarin.Designer.html#generate_mandarin_html_for_all/3","title":"Mandarin.Designer.generate_mandarin_html_for_all/3","type":"function"},{"doc":"Generate a mandarin schema (without generating a context or any web interface). This might be useful for schemas that are meant to act only as join_through tables for many-to-many relations. These schemas don't require a context or a web interface. In fact, the user is not meant to interact with them directly. Ecto will be capable of using them when required if the schemas are configured correctly.","ref":"Mandarin.Designer.html#generate_mandarin_schema/2","title":"Mandarin.Designer.generate_mandarin_schema/2","type":"function"},{"doc":"Install Mandarin into the given context . The context should be an upper case plural string (this function doesn't take a ) Example install_mandarin ( &quot;Admin&quot; )","ref":"Mandarin.Designer.html#install_mandarin/1","title":"Mandarin.Designer.install_mandarin/1","type":"function"},{"doc":"Create a foreign key reference","ref":"Mandarin.Designer.html#references/1","title":"Mandarin.Designer.references/1","type":"function"},{"doc":"Tag a field as unique.","ref":"Mandarin.Designer.html#unique/1","title":"Mandarin.Designer.unique/1","type":"function"},{"doc":"Update the options for a list","ref":"Mandarin.Designer.html#update_options/2","title":"Mandarin.Designer.update_options/2","type":"function"},{"doc":"Run a function ( fun ) which may create migration files and add marker files to migrations path to delimit which migrations were generated. This makes it easier to see which migrations were generated as a group. The migration files will contain the tag in the file name, so you may want to make it descriptive.","ref":"Mandarin.Designer.html#with_ecto_design_markers/3","title":"Mandarin.Designer.with_ecto_design_markers/3","type":"function"},{"doc":"Macros to simplify the definition of routes.","ref":"Mandarin.Router.html","title":"Mandarin.Router","type":"module"},{"doc":"Prints Mandarin tasks and their information. mix mandarin","ref":"Mix.Tasks.Mandarin.html","title":"Mix.Tasks.Mandarin","type":"task"},{"doc":"Generates authentication logic for a resource. $ mix mandarin . gen . auth Accounts User users The first argument is the context module followed by the schema module and its plural name (used as the schema table name). Additional information and security considerations are detailed in the mix mandarin.gen.auth guide . Password hashing The password hashing mechanism defaults to bcrypt for Unix systems and pbkdf2 for Windows systems. Both systems use the Comeonin interface . The password hashing mechanism can be overridden with the --hashing-lib option. The following values are supported: bcrypt - bcrypt_elixir pbkdf2 - pbkdf2_elixir argon2 - argon2_elixir We recommend developers to consider using argon2 , which is the most robust of all 3. The downside is that argon2 is quite CPU and memory intensive, and you will need more powerful instances to run your applications on. For more information about choosing these libraries, see the Comeonin project . Web namespace By default, the controllers and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: $ mix mandarin . gen . auth Accounts User users -- web Warehouse Which would generate the controllers, views, templates and associated tests nested in the MyAppWeb.Warehouse namespace: lib/my_app_web/controllers/warehouse/user_auth.ex lib/my_app_web/controllers/warehouse/user_confirmation_controller.ex lib/my_app_web/views/warehouse/user_confirmation_view.ex lib/my_app_web/templates/warehouse/user_confirmation/new.html.heex test/my_app_web/controllers/warehouse/user_auth_test.exs test/my_app_web/controllers/warehouse/user_confirmation_controller_test.exs and so on... Binary ids The --binary-id option causes the generated migration to use binary_id for its primary key and foreign keys. Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration. Custom table names By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: $ mix mandarin . gen . auth Accounts User users -- table accounts_users This will cause the generated tables to be named &quot;accounts_users&quot; and &quot;accounts_users_tokens&quot; .","ref":"Mix.Tasks.Mandarin.Gen.Auth.html","title":"Mix.Tasks.Mandarin.Gen.Auth","type":"task"},{"doc":"Generates a context with functions around an Ecto schema. mix mandarin . gen . context Admin User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/your_app : a context module in accounts/admin.ex , serving as the API boundary a schema in admin/user.ex , with a users table A migration file for the repository and test files for the context will also be generated. Generating without a schema In some cases, you may wish to bootstrap the context module and tests, but leave internal implementation of the context and schema to yourself. Use the --no-schema flags to accomplish this. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . context Admin User users -- table cms_users binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for mandarin.gen.schema for more information on attributes.","ref":"Mix.Tasks.Mandarin.Gen.Context.html","title":"Mix.Tasks.Mandarin.Gen.Context","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Context.html#prompt_for_code_injection/1","title":"Mix.Tasks.Mandarin.Gen.Context.prompt_for_code_injection/1","type":"function"},{"doc":"Generates controller, views, and context for an HTML resource. mix mandarin . gen . html Admin User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as admin.User and Payments.User ). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/ : a context module in lib/app/admin/admin.ex for the admin API a schema in lib/app/admin/user.ex , with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Mandarin generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web , :generators , context_app : :my_app Alternatively, the --context-app option may be supplied to the generator: mix mandarin . gen . html Sales User users -- context - app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix mandarin . gen . html Sales User users -- web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex . Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . html admin User users -- table cms_users binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for mandarin.gen.schema for more information on attributes.","ref":"Mix.Tasks.Mandarin.Gen.Html.html","title":"Mix.Tasks.Mandarin.Gen.Html","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Html.html#inputs/1","title":"Mix.Tasks.Mandarin.Gen.Html.inputs/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Gen.Html.html#routes_for_context/1","title":"Mix.Tasks.Mandarin.Gen.Html.routes_for_context/1","type":"function"},{"doc":"Generates a notifier that delivers emails by default. $ mix mandarin . gen . notifier Accounts User welcome_user reset_password confirmation_instructions This task expects a context module name, followed by a notifier name and one or more message names. Messages are the functions that will be created prefixed by &quot;deliver&quot;, so the message name should be &quot;snake_case&quot; without punctuation. Additionally a context app can be specified with the flag --context-app , which is useful if the notifier is being generated in a different app under an umbrella. $ mix mandarin . gen . notifier Accounts User welcome_user -- context - app marketing The app &quot;marketing&quot; must exist before the command is executed.","ref":"Mix.Tasks.Mandarin.Gen.Notifier.html","title":"Mix.Tasks.Mandarin.Gen.Notifier","type":"task"},{"doc":"Generates an Ecto schema and migration. mix mandarin . gen . schema Blog.Post blog_posts title :string views :integer The first argument is the schema module followed by its plural name (used as the table name). The generated schema above will contain: a schema file in lib/my_app/blog/post.ex , with a blog_posts table a migration file for the repository The generated migration can be skipped with --no-migration . Contexts Your schemas can be generated and added to a separate OTP app. Make sure your configuration is properly setup or manually specify the context app with the --context-app option with the CLI. # Via config config :marketing_web , :generators , context_app : :marketing # Via CLI mix mandarin . gen . schema Blog.Post blog_posts title :string views :integer -- context - app marketing Attributes The resource fields are given using name:type syntax where type are the types supported by Ecto. Omitting the type makes it default to :string : mix mandarin . gen . schema Blog.Post blog_posts title views :integer The following types are supported: :integer :float :decimal :boolean :map :string :array :references :text :date :time :naive_datetime :utc_datetime :uuid :binary :datetime - An alias for :naive_datetime The generator also supports references, which we will properly associate the given column to the primary key column of the referenced table: mix mandarin . gen . schema Blog.Post blog_posts title user_id :references :users This will result in a migration with an :integer column of :user_id and create an index. TODO: Support many-to-many relations. Furthermore an array type can also be given if it is supported by your database, although it requires the type of the underlying array element to be given too: mix mandarin . gen . schema Blog.Post blog_posts tags :array :string Unique columns can be automatically generated by using: mix mandarin . gen . schema Blog.Post blog_posts title :unique unique_int :integer :unique If no data type is given, it defaults to a string. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix mandarin . gen . schema Blog.Post posts -- table cms_posts binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration.","ref":"Mix.Tasks.Mandarin.Gen.Schema.html","title":"Mix.Tasks.Mandarin.Gen.Schema","type":"task"},{"doc":"Removes a mandarin context from your application","ref":"Mix.Tasks.Mandarin.Install.html","title":"Mix.Tasks.Mandarin.Install","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#build/3","title":"Mix.Tasks.Mandarin.Install.build/3","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#files_to_be_generated/1","title":"Mix.Tasks.Mandarin.Install.files_to_be_generated/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#sidebar_path/2","title":"Mix.Tasks.Mandarin.Install.sidebar_path/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Install.html#write_p!/2","title":"Mix.Tasks.Mandarin.Install.write_p!/2","type":"function"},{"doc":"Uninstalls the context from your application. This task removes the files and directories created by the mix mandarin.install task.","ref":"Mix.Tasks.Mandarin.Uninstall.html","title":"Mix.Tasks.Mandarin.Uninstall","type":"task"},{"doc":"","ref":"Mix.Tasks.Mandarin.Uninstall.html#build/3","title":"Mix.Tasks.Mandarin.Uninstall.build/3","type":"function"},{"doc":"","ref":"Mix.Tasks.Mandarin.Uninstall.html#write_p!/2","title":"Mix.Tasks.Mandarin.Uninstall.write_p!/2","type":"function"},{"doc":"Mandarin Generators to help you write an admin interface for your Phoenix application.","ref":"readme.html","title":"Mandarin","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding mandarin to your list of dependencies in mix.exs : def deps do [ { :mandarin , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Mandarin - Installation","type":"extras"},{"doc":"Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/mandarin . You can find a guide to an example admin interface at Backofice Demo . File Layout Instead of splitting the web-related files into different directories (one for controllers, one for views and one for templates), like Phoenix does by default, Mandarin groups your files into feature folders, as discussed here and here . Essentially, instead of this: 🗀 hello_web / 🗀 controllers / foo_controller . ex bar_controller . ex ... 🗀 templates / 🗀 foo index . html . heex ... 🗀 bar / index . html . heex ... 🗀 views / foo_view . heex bar_view . heex ... You have this: 🗀 hello_web 🗀 foo / foo_controller . ex foo_view . ex 🗀 templates / index . html . heex ... 🗀 bar / bar_controller . ex bar_view . ex 🗀 templates / index . html . heex ... The main advantage of the new layout is that it puts everything close together and it makes it easier to customize the controller and the template at the same time. It also makes it easier to delete all files related to a resource if for some reason things are not exactly right. It keeps everything related to your admin interface in one place and draws a cleaner boundary between the admin interface and the rest of your application.","ref":"readme.html#documentation-and-examples","title":"Mandarin - Documentation and Examples","type":"extras"},{"doc":"Mandarin is based on generators. The generators work the same as the default phoenix mandarin.gen.html generator. First, you must &quot;install&quot; mandarin into your application: mix mandarin.install NewContext The mandarin.install generator creates a new context in your application and adds the mandarin.ex file to your application. This file is similar to the YourApp.ex file generated by the mandarin.new generator. It contains a __using__/1 macro that allows you to use YourApp.Mandarin, :controller and use YourApp.Mandarin, :view . After creating the new context, you can add new resources to it, using the mandarin.gen.html generator, which takes the same arguments as the Phoenix mandarin.gen.html generator. This will create an ecto schema inside your context, a database migration and a new controller with CRUD functionality. Remember that Ecto allows two or more schemas to share the same database table. This means you can (and should!) have a one Ecto schema for the Admin interface Because the Admin interface is just a context, you can have multiple admin interfaces in your application if you want. For example, you could have an admin interface for &quot;normal&quot; admins, with some limits on what they can do and some safeguards in place, and another interface for &quot;superadmins&quot;, which can do literally everything to the database. To do that, just generate different contexts: mandarin.install LowLevelAdmin mandarin.install SuperAdmin The mandarin.gen.html works just like the normal Phoenix generators: mix mandarin.gen.html Admin Employee employees \\ full_name:string address:string fiscal_number:string \\ department:references:departments function:references:functions \\ begin_date:date end_date:date --binary-id For a hands-on guide on how to use the generators, see here .","ref":"readme.html#mandarin-generators","title":"Mandarin - Mandarin Generators","type":"extras"},{"doc":"The pages generated by Mandarin sit on top of functionality provided by the Forage package. Forage is a helper package containing HTML widgets and functions to dynamically create Ecto queries from query parameters. This allows mandarin to support pagingation and filtering of resources. Forage isn't wey well documented and tested yet, but it works pretty well together with Mandarin.","ref":"readme.html#forage","title":"Mandarin - Forage","type":"extras"},{"doc":"Interested people can contribute to Mandarin through one of the following: Reporting bugs - the GitHub issue tracker is currently the best place for that Fixing new bugs Suggesting improvements - again, by using the GitHub issue tracker The following should be considered out of scope for Mandarin for the foreseeable future: Replacing the code generators with macros, schema reflection or other kinds of metaprogramming (you already have Kaffy for that)","ref":"readme.html#contributing","title":"Mandarin - Contributing","type":"extras"},{"doc":"Backoffice Demo A simple demo of how to use Mandarin to implement a simple backoffice area for your Phoenix web application.","ref":"backoffice_demo.html","title":"Backoffice Demo","type":"extras"},{"doc":"Mandarin is a set of generators inspired by the Phoenix CRUD generators which can help in writing admin interface for you web application. The generators are inspired by the default phoenix.gen.* generators, and follow almost exactly the same structures. These generators generate normal phoenix conrollers, views and templates, which you can customize to your liking. The generated code may be quite verbose, but because it's normal elixir code , it's also trivial to customize to your liking (it would be pretty impossible to customize if it were based on metaprogramming). This approach is different from the one found in admin frameworks from other languages, which use class reflection or metaprogramming, such as some Python frameworks ( Django , Flask-Admin , Flask-AppBuilder ) and Ruby frameworks ( ActiveAdmin ). This application we'll develop in this guide is inspired by the small example in the Flask-Appbuider docs . The main difference is that we'll write ir using the Mandarin generators, while the AppBuilder version will uses class reflection.","ref":"backoffice_demo.html#introduction","title":"Backoffice Demo - Introduction","type":"extras"},{"doc":"We'll generate an admin interface that manages 3 different kinds of resources: Employees Departments, where each employee belongs to a single department Functions, where each employee has a single function This structure will show how Mandarin generators handle one-to-many relations (a future version will show how they handle many-to-many relations).","ref":"backoffice_demo.html#application-layout","title":"Backoffice Demo - Application Layout","type":"extras"},{"doc":"# mix.exs defp deps do [ # ... # Mandarin { :mandarin , path : &quot;../mandarin&quot; } , { :forage , path : &quot;../forage&quot; , override : true } , # Utilities to generate fake data { :faker , &quot;~&gt; 0.16&quot; , only : :dev } ] end","ref":"backoffice_demo.html#add-the-dependencies","title":"Backoffice Demo - Add the Dependencies","type":"extras"},{"doc":"You can have as many admin interfaces in your application as you want. An admin interface is just a new context with schemas, views, controllers and templates generated by Mandarin. You &quot;install&quot; mandarin into your application by giving it a new context name. Mandarin will then generate everything under that context. mix mandarin.install Backoffice","ref":"backoffice_demo.html#install-mandarin-into-your-application","title":"Backoffice Demo - &quot;Install&quot; Mandarin Into Your Application","type":"extras"},{"doc":"Mandarin provides generators, which are similar to the default Phoenix generators. The goal is to build your CRUD interface with the generators, and maybe customize the interface later if you feel the need to. Mandarin will generate and application structure which is quite similar to the default phoenix structure. The main difference is the use of &quot;vertical slicing&quot; or &quot;feature folders&quot;. You can now generate the pages for our resources with the generators. Department Type the following (and answer Yes to the prompts as needed): mix mandarin.gen.html Backoffice Department departments \\ name:string description:text --binary-id Function mix mandarin.gen.html Backoffice Function functions name:string --binary-id Employee mix mandarin.gen.html Backoffice Employee employees \\ full_name:string address:string fiscal_number:string \\ department:references:departments function:references:functions \\ begin_date:date end_date:date --binary-id","ref":"backoffice_demo.html#add-the-resources-to-the-mandarin-context","title":"Backoffice Demo - Add the Resources to the Mandarin Context","type":"extras"},{"doc":"Mandarin has generated some tests for your context and controllers. The tests are pretty basic, but they at least test that the relevant pages load without errors and invoke the appropriate actions in your Repo. You can run the automatically generated tests with: mix test","ref":"backoffice_demo.html#testing","title":"Backoffice Demo - Testing","type":"extras"},{"doc":"Alias the context module, which we will use to create our resources: alias MandarinDemo.Backoffice Create some WH40k-inspired departments for our company: department_names = [ &quot;Inquisition&quot; , &quot;Oficia Censorum&quot; , &quot;Ordo Xenos&quot; , &quot;Ordo Malleus&quot; , &quot;Sororitas&quot; , &quot;Adeptus Astartes&quot; ] # Gather the departments after inserting them into the database # because we&#39;ll be using them later. departments = for name &lt;- department_names do { :ok , department } = Backoffice . create_department ( %{ name : name , # Generate a random description using Faker description : Faker.Lorem . paragraph ( 1 .. 2 ) } ) department end A above, create some functions for our employees: function_names = [ &quot;Janitor&quot; , &quot;Office Clerk&quot; , &quot;Lector&quot; , &quot;Servitor&quot; , &quot;Adeptus&quot; , &quot;Maestrus&quot; , &quot;Techpriest&quot; , &quot;Cook&quot; , &quot;Custodes&quot; ] # Gather the functions after inserting them into the database # because we&#39;ll be using them later. functions = for name &lt;- function_names do { :ok , function } = Backoffice . create_function ( %{ name : name } ) function end Add some employees belonging to random functions and departments: _employees = for i &lt;- 1 .. 500 do { :ok , employee } = Backoffice . create_employee ( %{ address : Faker.Address.En . street_address ( ) , begin_date : Faker.Date . backward ( _days = 365 * 100 ) , end_date : Faker.Date . forward ( _days = 365 * 100 ) , fiscal_number : &quot;SSN- \#{ Enum . random ( 0 .. 1000_000_000 ) } &quot; , full_name : Faker.Person.En . name ( ) , function_id : Enum . random ( functions ) . id , department_id : Enum . random ( departments ) . id } ) end","ref":"backoffice_demo.html#generate-some-fake-data","title":"Backoffice Demo - Generate Some Fake Data","type":"extras"},{"doc":"...","ref":"backoffice_demo.html#playing-with-the-application","title":"Backoffice Demo - Playing with The Application","type":"extras"}]